# -*- coding: utf8 -*-
from django.utils.translation import ugettext_lazy as _lazy


ALL_CURRENCIES = {
    'AED': _lazy(u'United Arab Emirates Dirham'),
    'AFN': _lazy(u'Afghanistan Afghani'),
    'ALL': _lazy(u'Albania Lek'),
    'AMD': _lazy(u'Armenia Dram'),
    'ANG': _lazy(u'Netherlands Antilles Guilder'),
    'AOA': _lazy(u'Angola Kwanza'),
    'ARS': _lazy(u'Argentina Peso'),
    'AUD': _lazy(u'Australia Dollar'),
    'AWG': _lazy(u'Aruba Guilder'),
    'AZN': _lazy(u'Azerbaijan New Manat'),
    'BAM': _lazy(u'Bosnia and Herzegovina Convertible Marka'),
    'BBD': _lazy(u'Barbados Dollar'),
    'BDT': _lazy(u'Bangladesh Taka'),
    'BGN': _lazy(u'Bulgaria Lev'),
    'BHD': _lazy(u'Bahrain Dinar'),
    'BIF': _lazy(u'Burundi Franc'),
    'BMD': _lazy(u'Bermuda Dollar'),
    'BND': _lazy(u'Brunei Darussalam Dollar'),
    'BOB': _lazy(u'Bolivia Boliviano'),
    'BRL': _lazy(u'Brazil Real'),
    'BSD': _lazy(u'Bahamas Dollar'),
    'BTN': _lazy(u'Bhutan Ngultrum'),
    'BWP': _lazy(u'Botswana Pula'),
    'BYR': _lazy(u'Belarus Ruble'),
    'BZD': _lazy(u'Belize Dollar'),
    'CAD': _lazy(u'Canada Dollar'),
    'CDF': _lazy(u'Congo/Kinshasa Franc'),
    'CHF': _lazy(u'Switzerland Franc'),
    'CLP': _lazy(u'Chile Peso'),
    'CNY': _lazy(u'China Yuan Renminbi'),
    'COP': _lazy(u'Colombia Peso'),
    'CRC': _lazy(u'Costa Rica Colon'),
    'CUC': _lazy(u'Cuba Convertible Peso'),
    'CUP': _lazy(u'Cuba Peso'),
    'CVE': _lazy(u'Cape Verde Escudo'),
    'CZK': _lazy(u'Czech Republic Koruna'),
    'DJF': _lazy(u'Djibouti Franc'),
    'DKK': _lazy(u'Denmark Krone'),
    'DOP': _lazy(u'Dominican Republic Peso'),
    'DZD': _lazy(u'Algeria Dinar'),
    'EGP': _lazy(u'Egypt Pound'),
    'ERN': _lazy(u'Eritrea Nakfa'),
    'ETB': _lazy(u'Ethiopia Birr'),
    'EUR': _lazy(u'Euro Member Countries'),
    'FJD': _lazy(u'Fiji Dollar'),
    'FKP': _lazy(u'Falkland Islands (Malvinas) Pound'),
    'GBP': _lazy(u'United Kingdom Pound'),
    'GEL': _lazy(u'Georgia Lari'),
    'GGP': _lazy(u'Guernsey Pound'),
    'GHS': _lazy(u'Ghana Cedi'),
    'GIP': _lazy(u'Gibraltar Pound'),
    'GMD': _lazy(u'Gambia Dalasi'),
    'GNF': _lazy(u'Guinea Franc'),
    'GTQ': _lazy(u'Guatemala Quetzal'),
    'GYD': _lazy(u'Guyana Dollar'),
    'HKD': _lazy(u'Hong Kong Dollar'),
    'HNL': _lazy(u'Honduras Lempira'),
    'HRK': _lazy(u'Croatia Kuna'),
    'HTG': _lazy(u'Haiti Gourde'),
    'HUF': _lazy(u'Hungary Forint'),
    'IDR': _lazy(u'Indonesia Rupiah'),
    'ILS': _lazy(u'Israel Shekel'),
    'IMP': _lazy(u'Isle of Man Pound'),
    'INR': _lazy(u'India Rupee'),
    'IQD': _lazy(u'Iraq Dinar'),
    'IRR': _lazy(u'Iran Rial'),
    'ISK': _lazy(u'Iceland Krona'),
    'JEP': _lazy(u'Jersey Pound'),
    'JMD': _lazy(u'Jamaica Dollar'),
    'JOD': _lazy(u'Jordan Dinar'),
    'JPY': _lazy(u'Japan Yen'),
    'KES': _lazy(u'Kenya Shilling'),
    'KGS': _lazy(u'Kyrgyzstan Som'),
    'KHR': _lazy(u'Cambodia Riel'),
    'KMF': _lazy(u'Comoros Franc'),
    'KPW': _lazy(u'Korea (North) Won'),
    'KRW': _lazy(u'Korea (South) Won'),
    'KWD': _lazy(u'Kuwait Dinar'),
    'KYD': _lazy(u'Cayman Islands Dollar'),
    'KZT': _lazy(u'Kazakhstan Tenge'),
    'LAK': _lazy(u'Laos Kip'),
    'LBP': _lazy(u'Lebanon Pound'),
    'LKR': _lazy(u'Sri Lanka Rupee'),
    'LRD': _lazy(u'Liberia Dollar'),
    'LSL': _lazy(u'Lesotho Loti'),
    'LTL': _lazy(u'Lithuania Litas'),
    'LVL': _lazy(u'Latvia Lat'),
    'LYD': _lazy(u'Libya Dinar'),
    'MAD': _lazy(u'Morocco Dirham'),
    'MDL': _lazy(u'Moldova Leu'),
    'MGA': _lazy(u'Madagascar Ariary'),
    'MKD': _lazy(u'Macedonia Denar'),
    'MMK': _lazy(u'Myanmar (Burma) Kyat'),
    'MNT': _lazy(u'Mongolia Tughrik'),
    'MOP': _lazy(u'Macau Pataca'),
    'MRO': _lazy(u'Mauritania Ouguiya'),
    'MUR': _lazy(u'Mauritius Rupee'),
    'MVR': _lazy(u'Maldives (Maldive Islands) Rufiyaa'),
    'MWK': _lazy(u'Malawi Kwacha'),
    'MXN': _lazy(u'Mexico Peso'),
    'MYR': _lazy(u'Malaysia Ringgit'),
    'MZN': _lazy(u'Mozambique Metical'),
    'NAD': _lazy(u'Namibia Dollar'),
    'NGN': _lazy(u'Nigeria Naira'),
    'NIO': _lazy(u'Nicaragua Cordoba'),
    'NOK': _lazy(u'Norway Krone'),
    'NPR': _lazy(u'Nepal Rupee'),
    'NZD': _lazy(u'New Zealand Dollar'),
    'OMR': _lazy(u'Oman Rial'),
    'PAB': _lazy(u'Panama Balboa'),
    'PEN': _lazy(u'Peru Nuevo Sol'),
    'PGK': _lazy(u'Papua New Guinea Kina'),
    'PHP': _lazy(u'Philippines Peso'),
    'PKR': _lazy(u'Pakistan Rupee'),
    'PLN': _lazy(u'Poland Zloty'),
    'PYG': _lazy(u'Paraguay Guarani'),
    'QAR': _lazy(u'Qatar Riyal'),
    'RON': _lazy(u'Romania New Leu'),
    'RSD': _lazy(u'Serbia Dinar'),
    'RUB': _lazy(u'Russia Ruble'),
    'RWF': _lazy(u'Rwanda Franc'),
    'SAR': _lazy(u'Saudi Arabia Riyal'),
    'SBD': _lazy(u'Solomon Islands Dollar'),
    'SCR': _lazy(u'Seychelles Rupee'),
    'SDG': _lazy(u'Sudan Pound'),
    'SEK': _lazy(u'Sweden Krona'),
    'SGD': _lazy(u'Singapore Dollar'),
    'SHP': _lazy(u'Saint Helena Pound'),
    'SLL': _lazy(u'Sierra Leone Leone'),
    'SOS': _lazy(u'Somalia Shilling'),
    'SPL': _lazy(u'Seborga Luigino'),
    'SRD': _lazy(u'Suriname Dollar'),
    'STD': _lazy(u'São Tomé and Príncipe Dobra'),
    'SVC': _lazy(u'El Salvador Colon'),
    'SYP': _lazy(u'Syria Pound'),
    'SZL': _lazy(u'Swaziland Lilangeni'),
    'THB': _lazy(u'Thailand Baht'),
    'TJS': _lazy(u'Tajikistan Somoni'),
    'TMT': _lazy(u'Turkmenistan Manat'),
    'TND': _lazy(u'Tunisia Dinar'),
    'TOP': _lazy("Tonga Pa'anga"),
    'TRY': _lazy(u'Turkey Lira'),
    'TTD': _lazy(u'Trinidad and Tobago Dollar'),
    'TVD': _lazy(u'Tuvalu Dollar'),
    'TWD': _lazy(u'Taiwan New Dollar'),
    'TZS': _lazy(u'Tanzania Shilling'),
    'UAH': _lazy(u'Ukraine Hryvna'),
    'UGX': _lazy(u'Uganda Shilling'),
    'USD': _lazy(u'United States Dollar'),
    'UYU': _lazy(u'Uruguay Peso'),
    'UZS': _lazy(u'Uzbekistan Som'),
    'VEF': _lazy(u'Venezuela Bolivar'),
    'VND': _lazy(u'Viet Nam Dong'),
    'VUV': _lazy(u'Vanuatu Vatu'),
    'WST': _lazy(u'Samoa Tala'),
    'XAF': _lazy(u'Communauté Financière Africaine (BEAC) CFA Franc BEAC'),
    'XCD': _lazy(u'East Caribbean Dollar'),
    'XDR': _lazy(u'International Monetary Fund (IMF) Special Drawing Rights'),
    'XOF': _lazy(u'Communauté Financière Africaine (BCEAO) Franc'),
    'XPF': _lazy(u'Comptoirs Français du Pacifique (CFP) Franc'),
    'YER': _lazy(u'Yemen Rial'),
    'ZAR': _lazy(u'South Africa Rand'),
    'ZMW': _lazy(u'Zambia Kwacha'),
    'ZWD': _lazy(u'Zimbabwe Dollar')
}
